Open In App

Python Program for Minimum number of jumps to reach end

Last Updated : 24 Oct, 2023
Improve
Improve
Like Article
Like
Save
Share
Report

Write a Python program for a given array arr[] where each element represents the maximum number of steps that can be made forward from that index. The task is to find the minimum number of jumps to reach the end of the array starting from index 0.
If an element is 0, then cannot move through that element.

Examples:

Input: arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9}
Output: 3 (1-> 3 -> 9 -> 9)
Explanation: Jump from 1st element to 2nd element as there is only 1 step. Now there are three options 5, 8 or 9. If 8 or 9 is chosen then the end node 9 can be reached. So 3 jumps are made.

Input: arr[] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}
Output: 10
Explanation: In every step a jump is needed so the count of jumps is 10.

Python Program for Minimum number of jumps to reach end using Recursion:

Start from the first element and recursively call for all the elements reachable from the first element. The minimum number of jumps to reach end from first can be calculated using the minimum value from the recursive calls. 

minJumps(start, end) = 1 + Min(minJumps(k, end)) for all k reachable from start.

Step-by-step approach:

  • Create a recursive function.
  • In each recursive call get all the reachable nodes from that index.
    • For each of the index call the recursive function.
    • Find the minimum number of jumps to reach the end from current index.
  • Return the minimum number of jumps from the recursive call.

Below is the implementation of the above approach:

Python3




# Python3 program to find Minimum
# number of jumps to reach end
 
# Returns minimum number of jumps
# to reach arr[h] from arr[l]
 
 
def minJumps(arr, l, h):
 
    # Base case: when source and
    # destination are same
    if (h == l):
        return 0
 
    # when nothing is reachable
    # from the given source
    if (arr[l] == 0):
        return float('inf')
 
    # Traverse through all the points
    # reachable from arr[l]. Recursively
    # get the minimum number of jumps
    # needed to reach arr[h] from
    # these reachable points.
    min = float('inf')
    for i in range(l + 1, h + 1):
        if (i < l + arr[l] + 1):
            jumps = minJumps(arr, i, h)
            if (jumps != float('inf') and
                    jumps + 1 < min):
                min = jumps + 1
 
    return min
 
 
# Driver program to test above function
arr = [1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9]
n = len(arr)
print('Minimum number of jumps to reach',
    'end is', minJumps(arr, 0, n-1))
 
# This code is contributed by Soumen Ghosh


Output

Minimum number of jumps to reach end is 3

Time complexity: O(nn). There are maximum n possible ways to move from an element. So the maximum number of steps can be nn.
Auxiliary Space: O(n). For recursion call stack.

Python Program for Minimum number of jumps to reach end Using Dynamic Programming (Memoization):

It can be observed that there will be overlapping subproblems. 
For example in array, arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9} minJumps(3, 9) will be called two times as arr[3] is reachable from arr[1] and arr[2]. So this problem has both properties (optimal substructure and overlapping subproblems) of Dynamic Programming.

Step-by-step approach:

  • Create memo[] such that memo[i] indicates the minimum number of jumps needed to reach memo[n-1] from memo[i] to store previously solved subproblems.
  • During the recursion call, if the same state is called more than once, then we can directly return the answer stored for that state instead of calculating again.
  • Otherwise, In each recursive call get all the reachable nodes from that index.
    • For each of the index call the recursive function.
    • Find the minimum number of jumps to reach the end from current index.

Below is the implementation of the above approach:

Python3




# Helper function to find the minimum jumps required to reach the end
def jump(nums, idx, end, memo):
    # We reached the end. No jumps to make further
    if idx == end:
        return 0
 
    if memo[idx] != -1:
        return memo[idx]
 
    min_jumps = float("inf")
 
    # We will try to make all possible jumps from the current index
    # and select the minimum of those.
    # It does not matter if we try from 1 to nums[idx] or from nums[idx] to 1.
    for j in range(nums[idx], 0, -1):
        # If we make this jump 'j' distance away from idx,
        # do we overshoot?
        # If we land within the nums, we will test further.
        if idx + j <= end:
            # Make a jump to idx + j index and explore further,
            # then update min_jumps with the minimum jumps
            # we made to reach the end while trying all possible
            # nums[idx] jumps from the current index.
            min_jumps = min(min_jumps, 1 + jump(nums, idx + j, end, memo))
 
    memo[idx] = min_jumps
    return memo[idx]
 
 
def min_jumps(nums):
    """Memoization"""
 
    memo = [-1 for i in range(len(nums))]
    jump(nums, 0, len(nums) - 1, memo)
    return memo[0]
 
 
if __name__ == "__main__":
    arr = [1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9]
    print(min_jumps(arr))
# this code is contributed by Rohit Singh


Output

3

Time complexity: O(n2)
Auxiliary Space: O(n), because of recursive stack space and memo array.

Python Program for Minimum number of jumps to reach end using Dynamic Programming (Tabulation):

Step-by-step approach:

  • Create jumps[] array from left to right such that jumps[i] indicate the minimum number of jumps needed to reach arr[i] from arr[0].
  • To fill the jumps array run a nested loop inner loop counter is and the outer loop count is i.
    • Outer loop from 1 to n-1 and inner loop from 0 to i.
    • If i is less than j + arr[j] then set jumps[i] to minimum of jumps[i] and jumps[j] + 1. initially set jump[i] to INT MAX
  • Return jumps[n-1].

Below is the implementation of the above approach:

Python3




# Python3 program to find Minimum
# number of jumps to reach end
 
# Returns minimum number of jumps
# to reach arr[n-1] from arr[0]
 
 
def minJumps(arr, n):
    jumps = [0 for i in range(n)]
 
    if (n == 0) or (arr[0] == 0):
        return float('inf')
 
    jumps[0] = 0
 
    # Find the minimum number of
    # jumps to reach arr[i] from
    # arr[0] and assign this
    # value to jumps[i]
    for i in range(1, n):
        jumps[i] = float('inf')
        for j in range(i):
            if (i <= j + arr[j]) and (jumps[j] != float('inf')):
                jumps[i] = min(jumps[i], jumps[j] + 1)
                break
    return jumps[n-1]
 
 
# Driver Program to test above function
arr = [1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9]
size = len(arr)
print('Minimum number of jumps to reach',
    'end is', minJumps(arr, size))
 
# This code is contributed by Soumen Ghosh


Output

Minimum number of jumps to reach end is 3

Time Complexity: O(n2)
Auxiliary Space: O(n), since n extra space has been taken.

Please refer complete article on Minimum number of jumps to reach end for more details!



Like Article
Suggest improvement
Share your thoughts in the comments

Similar Reads